{ -

  ணࠬ ।祭  ᮧ  ।஢ ࠭ 䮭⮢
  ⥪⮢ ० 8025.   ⥭    䠩,
  㧪   ⥪饣 䮭.   ᬠਢ
  ।㥬 ᨬ  ࠫ 稭.
   ᯮ짮  ᮧ ᪨ 䮭⮢  䨪஢.
  ଠ   䠩:  ᨬ  16 ,   - 
  ப ⮢ ࠧ ᨬ. ᥣ ᨬ 256, 稭  ᨬ
  ASCII #0.

  ࠡ⠭ ⠭⨭ 㡭  1993 
  E-mail: const@const.krasnoyarsk.su
}

uses Crt, Display;

const
  CharTall = 16;				{  ᨬ VGA }

type
  Map = array[1..CharTall] of byte;		{ ⮢ ࠧ () ᨬ }

const
  WinX = 10;
  WinY = 5;
  MenuX = 45;
  MenuY = 5;
  CodeX = 45;
  CodeY = 17;
  MesX = 45;
  MesY = 15;
  Void = '';
  Fill = '';
  Menu: array[0..7] of string[27] =('F1   - Help    F2   - Save ',
				'F3   - Load    F4   - Copy ',
				'F5   - Put     F6   - Goto ',
				'F7   - Next    F8   - Prev ',
				'F9   - Undo    F10  - Quit ',
				'F11  - Get     F12  - Set  ', {Shift+F1  ..}
				'F13  - Clear   F14  - New  ',
				'F15  - Left    F16  - Right');

var
  CharMap: Map;
  CharTab: array[0..255] of Map;
  CharCod, CharNew: byte;
  MidStr, OldStr: string[2];
  PosX, PosY: byte;
  OldX, OldY: byte;
  Cnt1, Cnt2: byte;
  FlagEnd, FlagEdit: boolean;
  Sym, Sym1: char;
  FileName: string[30];
  FilePtr: file of byte;

procedure ClearMes;
begin
  GotoXY( MesX, MesY );
  ClrEol
end;

procedure OutMes( Message: string );
begin
  TextColor( Green);
  GotoXY( MesX, MesY );
  Write( Message )
end;

procedure OutCharCode;
begin
  TextColor( Cyan );
  GotoXY( CodeX + 16, CodeY );
  Write( CharCod:3 );
  GotoXY( CodeX + 16, CodeY + 1 );
  Write( Chr( CharCod ))
end;

function SetStr( X, Y: byte ): string;
begin
  if ( CharMap[Y] and ( $80 shr ( X - 1 ))) <> 0 then
    SetStr := Fill
  else
    SetStr := Void
end;

procedure OutCur;
begin
  OldX := PosX;
  OldY := PosY;
  OldStr := SetStr( PosX, PosY );
  TextColor( Green + Blink );
  GotoXY( PosX * 2 + WinX - 1, PosY + WinY );
  Write( OldStr );
  SetNewSymbol( @CharMap, 0, CharTall )
end;

procedure MoveCur;
begin
  TextColor( Green );
  GotoXY( OldX * 2 + WinX - 1, OldY + WinY );
  Write( OldStr );
  OutCur
end;

procedure OutMap;
begin
  TextColor( Green );
  GotoXY( WinX, WinY );
  Write( 'Ŀ' );
  for Cnt2 := 1 to CharTall do begin
    GotoXY( WinX, WinY + Cnt2 );
    Write( '' );
    for Cnt1 := 1 to 8 do Write( SetStr( Cnt1, Cnt2 ));
    Write( '', Cnt2:3 )
  end;
  GotoXY( WinX, WinY+17 );
  Write( '' );
  GotoXY( WinX, WinY+18 );
  Write( ' 1 2 3 4 5 6 7 8  ' );
  OutCur
end;

procedure CopyMap( Code: byte );
begin
  CharMap := CharTab[Code];
  FlagEdit := False;
  OutMap
end;

procedure ClearMap;
begin
  FillChar( CharMap, SizeOf( CharMap ), 0 );
  OutMap
end;

procedure NewFont;
begin
  FillChar( CharTab, SizeOf( CharTab ), 0 );
  CharCod := $80;
  ClearMap;
  OutCharCode
end;

procedure MoveMap;
begin
  CharTab[CharCod] := CharMap;
  OutMes( 'Symbol saved' );
  Delay( 500 );
  ClearMes
end;

function GetAnswer( Message: string ): boolean;
begin
  repeat
    OutMes( Message );
    Sym1 := ReadKey;
    ClearMes;
  until ( Sym1 = 'y' ) or ( Sym1 = 'n' );
  FlagEdit := False;
  if Sym1 = 'y' then
    GetAnswer := True
  else
    GetAnswer := False
end;

procedure GetFileName;
begin
  ShowCursor;
  OutMes( 'Enter file name: ' );
  Readln( FileName );
  HideCursor;
  ClearMes;
  Assign( FilePtr, FileName )
end;

procedure GetFont;
begin
  GetFontEGA( @CharTab, CharTall );
  CopyMap( CharCod )
end;

procedure AskSaveMap;
begin
  if FlagEdit then
    if GetAnswer( 'Symbol not save! Save it (y/n)?'#7 ) then
      MoveMap
end;

procedure SaveFont;

var
  TblPtr: ^byte;
  Cnt: word;

begin
  AskSaveMap;
  GetFileName;
  Reset( FilePtr );
  if IOResult = 0 then
    if ( FileName = '' ) or
	( not GetAnswer( 'Overwrite ' + FileName + ' (y/n)?' )) then begin
      Close( FilePtr );
      Exit
    end;
  Rewrite( FilePtr );
  OutMes( 'Font saved' );
  TblPtr := @CharTab;
  for Cnt := 1 to SizeOf( CharTab ) do begin
    Write( FilePtr, TblPtr^ );
    Inc( TblPtr )
  end;
  Close( FilePtr );
  ClearMes
end;

procedure LoadFont;

var
  TblPtr: ^byte;
  Cnt: word;

begin
  GetFileName;
  Reset( FilePtr );
  if ( IOResult <> 0 ) or ( FileName = '' ) then begin
    OutMes( 'Cannot find file ' + FileName );
    Delay( 800 );
    ClearMes;
    Exit
  end;
  OutMes( 'Font loaded' );
  TblPtr := @CharTab;
  for Cnt := 1 to SizeOf( CharTab ) do begin
    Read( FilePtr, TblPtr^ );
    Inc( TblPtr )
  end;
  ClearMes;
  Close( FilePtr );
  CopyMap( CharCod )
end;

procedure GotoChar;
begin
  ShowCursor;
  OutMes( 'Enter code of symbol: ' );
  Readln( CharCod );
  HideCursor;
  ClearMes;
  CopyMap( CharCod );
  OutCharCode
end;

procedure CopyChar;
begin
  ShowCursor;
  OutMes( 'Enter code of copied symbol: ' );
  Readln( CharNew );
  HideCursor;
  ClearMes;
  CopyMap( CharNew );
  FlagEdit := True
end;

procedure ShiftLeft;
begin
  for Cnt1 := 1 to CharTall do CharMap[Cnt1] := CharMap[Cnt1] shl 1;
  OutMap;
  FlagEdit := True
end;

procedure ShiftRight;
begin
  for Cnt1 := 1 to CharTall do CharMap[Cnt1] := CharMap[Cnt1] shr 1;
  OutMap;
  FlagEdit := True
end;

procedure OutMenu;
begin
  TextColor( LightGray );
  for Cnt1 := 0 to 7 do begin
    GotoXY( MenuX, MenuY + Cnt1 );
    Write( Menu[Cnt1] )
  end
end;


begin
  HideCursor;
  TextBackground( Black );
  ClrScr;
  OutMenu;
  GotoXY( CodeX, CodeY );
  Write( 'Code of symbol:' );
  GotoXY( CodeX, CodeY + 1 );
  Write( 'Old symbol map: ' );
  GotoXY( CodeX, CodeY + 2 );
  Write( 'New symbol map: ' );
  TextColor( LightCyan );
  Write( #0 );
  PosY := 1;
  PosX := 1;
  ClearMap;
  CharCod := $80;
  OutCharCode;
  FlagEnd := False;
  FlagEdit := False;
  SetCharMap( 4 );
  repeat
    Sym := ReadKey;
    if Sym = #0 then begin
      Sym := ReadKey;
      case Sym of
	#59: begin
	  OutMes( 'Sorry, help is not available' );
	  Delay( 800 );
	  ClearMes;
	end;
	#60: SaveFont;				{   䠩 }
	#61: LoadFont;				{   䠩 }
	#62: CopyChar;				{ ஢ ᨬ   ... }
	#63: begin
	  MoveMap;				{ ࠭ ।㥬 ᨬ  䮭 }
	  FlagEdit := False
	end;
	#64: GotoChar;				{ ३  ᨬ   ... }
	#65, #66: begin				{ ᫥騩/।騩 ᨬ }
	  AskSaveMap;
	  case Sym of
	    #65: Dec( CharCod );
	    #66: Inc( CharCod )
	  end;
	  OutCharCode;
	  CopyMap( CharCod );
	end;
	#67: CopyMap( CharCod );		{ ⬥  }
	#68: FlagEnd := True;			{  ࠡ }
	#72, #75, #77, #80: begin
	  case Sym of				{ ५ ६    }
	    #72: if PosY <> 1  then Dec( PosY ) else PosY := CharTall;
	    #80: if PosY <> CharTall then Inc( PosY ) else PosY := 1;
	    #77: if PosX <> 8  then Inc( PosX ) else PosX := 1;
	    #75: if PosX <> 1  then Dec( PosX ) else PosX := 8;
	  end;
	  MoveCur
	end;
	#84: if GetAnswer( 'Load font. Are you sure(y/n)?'#7 ) then GetFont;
						{ 㧨  ⥪饣 䮭 }
	#85: if GetAnswer( 'Save font. Are you sure(y/n)?'#7 ) then
	  SetFontEGA( @CharTab, CharTall );	{   ⥪騩 䮭 }
	#86: begin
	  ClearMap;				{    }
	  FlagEdit := True
	end;
	#87: if GetAnswer( 'Clear font. Are you sure(y/n)?'#7 ) then NewFont;
						{ ᮧ  䮭 }
	#88: ShiftLeft;				{ ᤢ ᨬ  }
	#89: ShiftRight				{ ᤢ ᨬ ࠢ }
      end
    end
    else if Sym = #32 then begin			{ ஡ ⠢/㡨ࠥ  }
      FlagEdit := True;
      CharMap[PosY] := CharMap[PosY] xor ( $80 shr ( PosX - 1 ));
      OutCur
    end
  until FlagEnd;
  SetCharMap( 0 );
  NormVideo;
  ClrScr;
  ShowCursor
end.